// Bmp2RgnDlg.cpp : implementation file
//(c) 1999, Till Toenshoff <till@uni.de>
//this code is FREE for any use

#include "stdafx.h"
#include "Bmp2Rgn.h"
#include "Bmp2RgnDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBmp2RgnDlg dialog

CBmp2RgnDlg::CBmp2RgnDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBmp2RgnDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBmp2RgnDlg)
	m_strSrc = _T("");
	m_strDst = _T("");
	m_nRed = 0;
	m_nGreen = 0;
	m_nBlue = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pBitmap=NULL;
}

void CBmp2RgnDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBmp2RgnDlg)
	DDX_Control(pDX, IDCALC, m_btnCalc);
	DDX_Control(pDX, IDC_COLOR, m_ctlColor);
	DDX_Control(pDX, IDOK, m_btnOk);
	DDX_Text(pDX, IDC_SRC, m_strSrc);
	DDX_Text(pDX, IDC_DST, m_strDst);
	DDX_Text(pDX, IDC_RED, m_nRed);
	DDV_MinMaxInt(pDX, m_nRed, 0, 255);
	DDX_Text(pDX, IDC_GREEN, m_nGreen);
	DDV_MinMaxInt(pDX, m_nGreen, 0, 255);
	DDX_Text(pDX, IDC_BLUE, m_nBlue);
	DDV_MinMaxInt(pDX, m_nBlue, 0, 255);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBmp2RgnDlg, CDialog)
	//{{AFX_MSG_MAP(CBmp2RgnDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BROWSE_DST, OnBrowseDst)
	ON_BN_CLICKED(IDC_BROWSE_SRC, OnBrowseSrc)
	ON_EN_CHANGE(IDC_SRC, OnChangeSrc)
	ON_EN_CHANGE(IDC_DST, OnChangeDst)
	ON_BN_CLICKED(IDCALC, OnCalc)
	ON_EN_CHANGE(IDC_BLUE, OnChangeBlue)
	ON_EN_CHANGE(IDC_GREEN, OnChangeGreen)
	ON_EN_CHANGE(IDC_RED, OnChangeRed)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_SETCOLOR,	OnSetColor)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBmp2RgnDlg message handlers

BOOL CBmp2RgnDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	enableControls ();
	m_ctlColor.SetColor (RGB(m_nRed,m_nBlue,m_nGreen));

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBmp2RgnDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBmp2RgnDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

LRESULT CBmp2RgnDlg::OnSetColor (WPARAM wParm,LPARAM lParm)
{
	COLORREF col=wParm;
	m_ctlColor.SetColor (col);
	m_nRed=GetRValue (col);
	m_nGreen=GetGValue (col);
	m_nBlue=GetBValue (col);
	UpdateData (FALSE);
	return 0;
}

void CBmp2RgnDlg::OnBrowseSrc() 
{
	// TODO: Add your control notification handler code here
	OPENFILENAME	ofn;				// common dialog box structure
	CString			str;

	char ndir[260]={"\0"},nname[1024]={"\0"};
	// Initialize OPENFILENAME
	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = GetSafeHwnd();
	ofn.hInstance = AfxGetInstanceHandle ();
	ofn.lpstrFile = nname;
	ofn.nMaxFile = sizeof(nname);
	ofn.lpstrFilter = "bitmap (*.bmp)\0*.BMP\0Alle\0*.*\0";
	ofn.nFilterIndex = 1;
	ofn.lpstrFileTitle = NULL;
	ofn.lpstrTitle = NULL;
	ofn.nMaxFileTitle = 0;
	ofn.lpstrInitialDir = ndir;
	ofn.Flags = OFN_PATHMUSTEXIST | 
				OFN_FILEMUSTEXIST | 
				OFN_EXPLORER | 
				OFN_ALLOWMULTISELECT |
				OFN_HIDEREADONLY;
	// Display the Open dialog box. 
	if (GetOpenFileName(&ofn) != TRUE) 
		return;
	m_strSrc=ofn.lpstrFile;
	UpdateData (FALSE);
	OnChangeSrc ();
}

void CBmp2RgnDlg::OnBrowseDst() 
{
	// TODO: Add your control notification handler code here
	OPENFILENAME	ofn;				// common dialog box structure
	CString			str;
	char			ndir[260]={"\0"},nname[1024]={"\0"};

	UpdateData (TRUE);
	strcpy (nname,m_strDst);

	// Initialize OPENFILENAME
	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = GetSafeHwnd();
	ofn.hInstance = AfxGetInstanceHandle ();
	ofn.lpstrFile = nname;
	ofn.nMaxFile = sizeof(nname);
	//if (m_bCombine)
	//	ofn.lpstrFilter = "binary CBitmap + CRgn (*.bmr)\0*.bmr\0Alle\0*.*\0";
	//else
	ofn.lpstrFilter = "binary CRgn (*.rgn)\0*.rgn\0Alle\0*.*\0";
	ofn.nFilterIndex = 1;
	ofn.lpstrFileTitle = NULL;
	ofn.lpstrTitle = NULL;
	ofn.nMaxFileTitle = 0;
	ofn.lpstrInitialDir = ndir;
	ofn.Flags = OFN_EXPLORER | 
				OFN_HIDEREADONLY;
	// Display the Open dialog box. 
	if (GetSaveFileName(&ofn) != TRUE) 
		return;
	m_strDst=str=ofn.lpstrFile;
	str.MakeUpper();
	if (str.Find (".RGN") == -1)
	{
		if (str.Find (".") == -1)
			m_strDst+=".rgn";
	}
	UpdateData (FALSE);
	OnChangeDst ();
}

void CBmp2RgnDlg::OnOK() 
{
	// TODO: Add extra validation here
	const char *MSGCAPTION="BMP To RGN Converter";
	CRgn *pRgn;
	CFile f;
	CFileException e;
	HGLOBAL hmem;
	RGNDATA *pRd;
	//BITMAP *pBm;
	int nSize;

	UpdateData (TRUE);
	if( !f.Open(m_strDst, CFile::modeCreate | CFile::modeWrite, &e ) )
	{
		MessageBox ("failed to create destination file",MSGCAPTION,MB_OK|MB_ICONSTOP);
		return;
	}
	//
	//get a pointer to the region
	pRgn=m_dlgPreview.GetRgn ();
	ASSERT (pRgn);
	//get size of region data
	nSize=pRgn->GetRegionData (NULL,0);
	ASSERT (nSize);
	if ((hmem=GlobalAlloc (GHND,nSize)) == NULL)
	{
		TRACE ("failed to alloc memory\n");
		return;
	}
	if ((pRd=(RGNDATA *)GlobalLock (hmem)) == NULL)
	{
		TRACE ("failed to lock memory\n");
		return;
	}
	//get the region data structure
	pRgn->GetRegionData (pRd,nSize);
	//write it to our file
	f.Write (pRd,nSize);
	//thats it...
	GlobalUnlock (hmem);
	GlobalFree (hmem);
	f.Close ();
	MessageBox ("done.",MSGCAPTION,MB_OK);
	CDialog::OnOK();
}

void CBmp2RgnDlg::LoadBitmap (const char *pPath,CBitmap **pBitmap)
{
	CFile f;
	HGLOBAL hmem1,hmem2;
	void *lpvBits;
	LPBITMAPINFO lpbmi;
	BITMAPFILEHEADER bmfh;
	BITMAPINFOHEADER bmih;
	int nSize;

	// open our source file
	if (f.Open (pPath,CFile::modeRead|CFile::shareDenyNone))
	{
		// retrieve the BITMAPFILEHEADER structure
		f.Read (&bmfh, sizeof(BITMAPFILEHEADER));
		// retrieve the BITMAPFILEHEADER structure.
		f.Read (&bmih, sizeof(BITMAPINFOHEADER));

		nSize=sizeof(BITMAPINFOHEADER);
		if (bmih.biBitCount <= 8)
			nSize+=(1<<bmih.biBitCount)*sizeof(RGBQUAD);

		// allocate memory for the BITMAPINFO structure  (header + palette)
		hmem1 = GlobalAlloc(GHND,nSize); 
		if (hmem1 == NULL)
		{
			TRACE ("LoadBitmap: no memory left in !\n");
			return;
		}
		lpbmi = (LPBITMAPINFO)GlobalLock(hmem1); 
		if (lpbmi == NULL)
		{
			TRACE ("LoadBitmap: could not lock memory !\n");
			return;
		}
 		// load BITMAPINFOHEADER into the BITMAPINFO structure
		lpbmi->bmiHeader.biSize = bmih.biSize; 
		lpbmi->bmiHeader.biWidth = bmih.biWidth; 
		lpbmi->bmiHeader.biHeight = bmih.biHeight; 
		lpbmi->bmiHeader.biPlanes = bmih.biPlanes; 
		lpbmi->bmiHeader.biBitCount = bmih.biBitCount; 
		lpbmi->bmiHeader.biCompression = bmih.biCompression; 
		lpbmi->bmiHeader.biSizeImage = bmih.biSizeImage; 
		lpbmi->bmiHeader.biXPelsPerMeter = bmih.biXPelsPerMeter; 
		lpbmi->bmiHeader.biYPelsPerMeter = bmih.biYPelsPerMeter; 
		lpbmi->bmiHeader.biClrUsed = bmih.biClrUsed; 
		lpbmi->bmiHeader.biClrImportant = bmih.biClrImportant; 
		ASSERT (bmih.biSize);
		ASSERT (bmih.biWidth);
		ASSERT (bmih.biHeight);
		// retrieve the color table. (if needed) 
		if (bmih.biBitCount <= 8)
 			f.Read (lpbmi->bmiColors,bmih.biClrUsed * sizeof(RGBQUAD));
		// allocate memory for the required number of bytes. 
		hmem2 = GlobalAlloc(GHND, (bmfh.bfSize - bmfh.bfOffBits)); 
		if (hmem2 == NULL)
		{
			TRACE ("LoadBitmap: no memory left in !\n");
			return;
		}
		lpvBits = GlobalLock(hmem2); 
		if (lpvBits == NULL)
		{
			TRACE ("LoadBitmap: could not lock memory !\n");
			return;
		}
		// retrieve the bitmap data
		f.Read (lpvBits,(bmfh.bfSize - bmfh.bfOffBits));
		// close the .BMP file
		f.Close ();

		// create a bitmap from the data stored in the .BMP file. 
		HBITMAP hbm;
		hbm = CreateDIBitmap(GetDC()->m_hDC,&bmih,CBM_INIT,lpvBits,lpbmi,DIB_RGB_COLORS); 
		if (hbm == NULL)
		{
			TRACE ("LoadBitmap: could not create DIB\n");
			return;
		}
		*pBitmap=CBitmap::FromHandle(hbm);
		// unlock the global memory objects
		GlobalUnlock(hmem1); 
		GlobalUnlock(hmem2); 
	}
}

void CBmp2RgnDlg::OnChangeSrc() 
{
	// TODO: Add your control notification handler code here
	UpdateData (TRUE);
	LoadBitmap (LPCSTR(m_strSrc),&m_pBitmap);
	if (m_pBitmap)
	{
		m_dlgBitmap.Setup (this);
		if (m_dlgBitmap.GetSafeHwnd() == NULL)
			m_dlgBitmap.Create (IDD_BITMAP_PANEL, this);
		m_dlgBitmap.ShowWindow (SW_SHOW);
		m_dlgBitmap.SetBitmap (m_pBitmap);
	}
	enableControls ();
}

void CBmp2RgnDlg::enableControls (void)
{
	if (!m_strSrc.IsEmpty() && m_pBitmap != NULL)
	{
		m_btnCalc.EnableWindow (TRUE);
		if (m_dlgPreview.GetSafeHwnd() && !m_strDst.IsEmpty())
			m_btnOk.EnableWindow (TRUE);
		else
			m_btnOk.EnableWindow (FALSE);
	}
	else
	{
		m_btnOk.EnableWindow (FALSE);
		m_btnCalc.EnableWindow (FALSE);
	}
}

void CBmp2RgnDlg::OnChangeDst() 
{
	// TODO: Add your control notification handler code here
	UpdateData (TRUE);
	enableControls ();
}

void CBmp2RgnDlg::OnCalc() 
{
	// TODO: Add your control notification handler code here
	CWaitCursor wait;
	if (m_pBitmap)
	{
		CRect rcbm,rc;
		m_dlgBitmap.GetWindowRect (&rcbm);
		m_dlgBitmap.SetWindowPos (	&wndTop,
									rcbm.Width(),
									0,
									0,
									0,
									SWP_NOSIZE);
		if (m_dlgPreview.GetSafeHwnd() == NULL)
			m_dlgPreview.Create (IDD_PREVIEW_PANEL, this);
		m_dlgPreview.ShowWindow (SW_SHOW);
		m_dlgPreview.SetWindowPos (	&wndTop,
									0,
									0,
									rcbm.Width(),
									rcbm.Height(),
									SWP_DRAWFRAME);
		m_dlgPreview.Setup (m_pBitmap,RGB(m_nRed,m_nGreen,m_nBlue));
	}
	enableControls ();
}

void CBmp2RgnDlg::OnChangeBlue() 
{
	// TODO: Add your control notification handler code here
	UpdateData (TRUE);
	m_ctlColor.SetColor (RGB(m_nRed,m_nGreen,m_nBlue));
}

void CBmp2RgnDlg::OnChangeGreen() 
{
	// TODO: Add your control notification handler code here
	UpdateData (TRUE);
	m_ctlColor.SetColor (RGB(m_nRed,m_nGreen,m_nBlue));
}

void CBmp2RgnDlg::OnChangeRed() 
{
	// TODO: Add your control notification handler code here
	UpdateData (TRUE);
	m_ctlColor.SetColor (RGB(m_nRed,m_nGreen,m_nBlue));
}
