// Display.cpp : implementation file
//(c) 1999, Till Toenshoff <till@uni.de>
//this code is FREE for any use

#include "stdafx.h"
#include "Bmp2Rgn.h"
#include "Display.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDisplay

CDisplay::CDisplay()
{
	m_pBitmap=NULL;
	m_Col=0;
}

CDisplay::~CDisplay()
{
}


BEGIN_MESSAGE_MAP(CDisplay, CStatic)
	//{{AFX_MSG_MAP(CDisplay)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDisplay message handlers
void CDisplay::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	CDC memdc;
	CRect rect;
	CBitmap *pold;

	GetClientRect (&rect);
	VERIFY(memdc.CreateCompatibleDC (&dc));
	if (m_pBitmap != NULL)
	{
		pold=memdc.SelectObject (m_pBitmap);
		dc.BitBlt (0,0,rect.Width(),rect.Height(),&memdc,0,0,SRCCOPY);
		memdc.SelectObject (pold);
		memdc.DeleteDC ();
	}
	else
	{
		CBitmap bmp;
		bmp.CreateCompatibleBitmap (&dc,rect.Width(),rect.Height());
		pold=memdc.SelectObject (&bmp);
		memdc.FillSolidRect (&rect,m_Col);
		dc.BitBlt (0,0,rect.Width(),rect.Height(),&memdc,0,0,SRCCOPY);
		memdc.SelectObject (pold);
		memdc.DeleteDC ();
		bmp.DeleteObject ();
	}
}

void CDisplay::SetColor (COLORREF col)
{
	m_Col=col;	
	Invalidate ();
}

void CDisplay::SetBitmap (CBitmap *pBitmap)
{
	ASSERT (pBitmap);
	m_pBitmap=pBitmap;	
	if (GetSafeHwnd())
	{
		BITMAP bm;
		VERIFY(m_pBitmap->GetBitmap(&bm));
		SetWindowPos (&wndTop,0,0,bm.bmWidth,bm.bmHeight,SWP_FRAMECHANGED);
		Invalidate ();
	}
}

COLORREF CDisplay::GetPointColor (CPoint &point)
{
	CDC *pDC=GetDC();
	ASSERT (pDC);
	return pDC->GetPixel (point.x,point.y);
}
