// DlgBitmap.cpp : implementation file
//(c) 1999, Till Toenshoff <till@uni.de>
//this code is FREE for any use


#include "stdafx.h"
#include "Bmp2Rgn.h"
#include "Display.h"
#include "DlgBitmap.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgBitmap dialog


CDlgBitmap::CDlgBitmap(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgBitmap::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgBitmap)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_pParent=pParent;
}


void CDlgBitmap::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgBitmap)
	DDX_Control(pDX, IDC_BITMAP, m_ctlDisplay);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgBitmap, CDialog)
	//{{AFX_MSG_MAP(CDlgBitmap)
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgBitmap message handlers

void CDlgBitmap::SetBitmap (CBitmap *pBitmap)
{
	const char *MSGCAPTION="Error";
	ASSERT (pBitmap);
	ASSERT (GetSafeHwnd());
	m_ctlDisplay.SetBitmap (pBitmap);
	SizeToFit();
}

void CDlgBitmap::SizeToFit (void)
{
	CRect rect;
	m_ctlDisplay.GetWindowRect (&rect);
	SetWindowPos (	&wndTop,
					0,
					0,
					rect.Width()+GetSystemMetrics(SM_CXDLGFRAME),
					rect.Height()+GetSystemMetrics(SM_CYDLGFRAME)+GetSystemMetrics(SM_CYCAPTION),
					SWP_NOREPOSITION);
}

void CDlgBitmap::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	COLORREF col;
	col=m_ctlDisplay.GetPointColor (point);
	ASSERT (m_pParent);
	m_pParent->SendMessage (WM_SETCOLOR,(WPARAM)col,0);
	CDialog::OnLButtonDown(nFlags, point);
}

void CDlgBitmap::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	CDialog::OnMouseMove(nFlags, point);
	static HCURSOR hold;
	HCURSOR hcurs;
	CRect rect;

	GetClientRect (&rect);
	if (rect.PtInRect(point))
	{
		if (GetCapture () != this)
		{
			SetCapture ();
			hcurs=AfxGetApp()->LoadCursor (IDC_PICK);
			hold=SetCursor (hcurs);
		}
	}
	else
	{
		ReleaseCapture ();
		SetCursor (hold);
	}
}
