// DlgView.cpp : implementation file
//(c) 1999, Till Toenshoff <till@uni.de>
//this code is FREE for any use

#include "stdafx.h"
#include "Bmp2Rgn.h"
#include "Display.h"
#include "DlgPreview.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgPreview dialog


CDlgPreview::CDlgPreview(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgPreview::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgPreview)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_pRgn=NULL;
	m_pBitmap=NULL;
}

void CDlgPreview::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgPreview)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDlgPreview, CDialog)
	//{{AFX_MSG_MAP(CDlgPreview)
	ON_WM_PAINT()
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgPreview message handlers

void CDlgPreview::Setup (CBitmap *pBitmap,COLORREF col)
{
	const char *MSGCAPTION="Error";
	ASSERT (pBitmap);
	m_pBitmap=pBitmap;
	if (GetSafeHwnd())
	{
		SizeToFit();
		if (m_pRgn)
			delete m_pRgn;
		m_pRgn=new CRgn;
		if (CreateRegion (m_pRgn,m_pBitmap,col))
		{
			if (!SetWindowRgn (GetSafeHwnd(),(HRGN)*m_pRgn,TRUE))
				MessageBox ("failed to set the region for this window",MSGCAPTION,MB_OK);
		}
		else
			MessageBox ("failed to create a region from bitmap\nNOTE: bitmap has to contain the key-color !",MSGCAPTION,MB_OK);
		Invalidate ();
	}
}

void CDlgPreview::SizeToFit (void)
{
	BITMAP bm;
	CRect rect;
	ASSERT (m_pBitmap);
	VERIFY(m_pBitmap->GetBitmap(&bm));
	SetWindowPos (&wndTop,0,0,bm.bmWidth,bm.bmHeight,SWP_NOREPOSITION);
}

//this is adopted (and changed a bit) from 
//Franz Polzer's article "Transparent Window" on www.codeguru.com
BOOL CDlgPreview::CreateRegion (CRgn *pRgn,CBitmap *pBitmap,COLORREF keycol)
{
	CDC					memDC;
	CBitmap				*pOldMemBmp = NULL;
	CRect				cRect;
	int					x, y;
	int					n=0;		//number of transparent pixels
	CRgn				rgnTemp;

	ASSERT (pRgn);
	ASSERT (pBitmap);
	GetWindowRect(&cRect);

	memDC.CreateCompatibleDC(GetDC());
	pOldMemBmp = memDC.SelectObject(pBitmap);

	pRgn->CreateRectRgn(0, 0, cRect.Width(), cRect.Height());
	for (x=0;x <= cRect.Width();x++)
	{
		for (y=0;y <= cRect.Height();y++)
		{
			if (memDC.GetPixel(x,y) == keycol)
			{
				rgnTemp.CreateRectRgn(x, y, x+1, y+1);
				pRgn->CombineRgn(pRgn, &rgnTemp, RGN_XOR);
				rgnTemp.DeleteObject();	
				++n;
			}
		}
	}
	if (pOldMemBmp) 
		memDC.SelectObject(pOldMemBmp);
	return n > 0;
}

CRgn *CDlgPreview::GetRgn (void)
{
	return m_pRgn;
}

void CDlgPreview::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	if (m_pBitmap != NULL)
	{
		CDC memdc;
		CRect rect;
		CBitmap *pold;

		GetWindowRect (&rect);
		VERIFY(memdc.CreateCompatibleDC (&dc));
		pold=memdc.SelectObject (m_pBitmap);
		dc.BitBlt (0,0,rect.Width(),rect.Height(),&memdc,0,0,SRCCOPY);
		memdc.SelectObject (pold);
		memdc.DeleteDC ();
	}
	// Do not call CDialog::OnPaint() for painting messages
}

void CDlgPreview::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	PostMessage(WM_NCLBUTTONDOWN, HTCAPTION, MAKELPARAM(point.x,point.y));
	CDialog::OnLButtonDown(nFlags, point);
}
