// DlgView.cpp : implementation file
//

#include "stdafx.h"
#include "Bmp2Rgn.h"
#include "DlgView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgPreview dialog


CDlgPreview::CDlgPreview(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgPreview::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgPreview)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_pRgn=NULL;
	m_pBitmap=NULL;
}

void CDlgPreview::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgPreview)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDlgPreview, CDialog)
	//{{AFX_MSG_MAP(CDlgPreview)
	ON_WM_PAINT()
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgPreview message handlers

BOOL CDlgPreview::OnInitDialog() 
{
	//
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization her
	/*
	SizeToFit();
	if (CreateRegion (&m_Rgn,m_pBitmap))
	{
		if (!SetWindowRgn (GetSafeHwnd(),(HRGN)m_Rgn,TRUE))
			MessageBox ("failed to set the region for this window",MSGCAPTION,MB_OK);
	}
	else
		MessageBox ("failed to create a region from bitmap\nNOTE: areas that should be transparent need to be RGB(0,0,0) !",MSGCAPTION,MB_OK);
		*/
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgPreview::SetBitmap (CBitmap *pBitmap)
{
	const char *MSGCAPTION="Error";
	ASSERT (pBitmap);
	m_pBitmap=pBitmap;
	if (GetSafeHwnd())
	{
		SizeToFit();
		if (m_pRgn)
			delete m_pRgn;
		m_pRgn=new CRgn;
		if (CreateRegion (m_pRgn,m_pBitmap))
		{
			if (!SetWindowRgn (GetSafeHwnd(),(HRGN)*m_pRgn,TRUE))
				MessageBox ("failed to set the region for this window",MSGCAPTION,MB_OK);
		}
		else
			MessageBox ("failed to create a region from bitmap\nNOTE: areas that should be transparent need to be RGB(0,0,0) !",MSGCAPTION,MB_OK);
		Invalidate ();
	}
}

void CDlgPreview::SizeToFit (void)
{
	BITMAP bm;
	ASSERT (m_pBitmap);
	VERIFY(m_pBitmap->GetBitmap(&bm));
	if (GetSafeHwnd() != NULL)
		SetWindowPos (&wndTop,0,0,bm.bmWidth,bm.bmHeight,SWP_FRAMECHANGED);
}

BOOL CDlgPreview::CreateRegion (CRgn *pRgn,CBitmap *pBitmap)
{
	CDC					memDC;
	CBitmap				*pOldMemBmp = NULL;
	COLORREF			col;
	CRect				cRect;
	int					x, y;
	int					n=0;		//number of transparent pixels
	CRgn				rgnTemp;

	ASSERT (pRgn);
	ASSERT (pBitmap);
	GetWindowRect(&cRect);

	memDC.CreateCompatibleDC(GetDC());
	pOldMemBmp = memDC.SelectObject(pBitmap);

	pRgn->CreateRectRgn(0, 0, cRect.Width(), cRect.Height());
	for(x=0; x<=cRect.Width(); x++)
	{
		for(y=0; y<=cRect.Height(); y++)
		{
			col = memDC.GetPixel(x, y);
			if(col == RGB(0,0,0))
			{
				rgnTemp.CreateRectRgn(x, y, x+1, y+1);
				pRgn->CombineRgn(pRgn, &rgnTemp, RGN_XOR);
				rgnTemp.DeleteObject();	
				++n;
			}
		}
	}
	if (pOldMemBmp) 
		memDC.SelectObject(pOldMemBmp);
	return n > 0;
}

CRgn *CDlgPreview::GetRgn (void)
{
	return m_pRgn;
}

void CDlgPreview::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	if (m_pBitmap != NULL)
	{
		CDC memdc;
		CRect rect;
		CBitmap *pold;

		GetWindowRect (&rect);
		VERIFY(memdc.CreateCompatibleDC (&dc));
		pold=memdc.SelectObject (m_pBitmap);
		dc.BitBlt (0,0,rect.Width(),rect.Height(),&memdc,0,0,SRCCOPY);
		memdc.SelectObject (pold);
		memdc.DeleteDC ();
	}
	// Do not call CDialog::OnPaint() for painting messages
}

void CDlgPreview::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	PostMessage(WM_NCLBUTTONDOWN, HTCAPTION, MAKELPARAM(point.x,point.y));
	CDialog::OnLButtonDown(nFlags, point);
}
